smi - Simple Markup Interpreter
===============================

smi is a Simple Markup Interpreter for simplified markup dialect.

**smi** will produce HTML output, by "interpreting"
[Markdown](http://daringfireball.net/projects/markdown/) formatted text.

**smi** is written in C. Is small, and easily built, and used. In fact; I use it for
a wiki! I might later, also create a Perl version of **smi**.

INSTALLATION
------------

Unpack the archive:

    $ tar -xvzf smi-N.N.tar.gz
    $ cd smi-N.N

where `N.N` represents the Version number(s).

followed by:

    $ make
    $ sudo make install

Done!

USAGE
-----

  **smi** [option] infile

  where **option** is currently **-h** (HELP) **-n** (**strict** mode), and
-v (VERSION)

**EXAMPLE**

    $ smi <Markdown-File>

will echo (dump) the (converted) output (<Markdown-File>) to STDOUT (your screen).

  **-n** -- a so-called "strict mode"

Here's an example using the **-n** switch.
The **-n** switch causes **smi** to be more "strict" about it's output.

    $ smi -n <Markdown-File>

Again; same syntax, but with *hopefully* more (HTML) "conformant" output.

More accurately; the **-n** switch is better designed to more strictly
escape HTML markup generated within the **output** file. Please see
"**bonus features**" below, for a better understanding of what this means.

BONUS FEATURES
--------------

A few things *possibly* worth noting;

You can re-direct the output to a filehandle (File Name) of your choosing;

eg;

    $ smi README.md > README.html

which will create an HTMLized README file (README.html) from the Markdown
formatted README.md file. The output file will still lack the <html>, <head>,
<body> tags, as well as their closing tags. But not having them makes it pretty
easy to include them within your web site templates.

Another *feature* of **smi**, is it's ability to turn that same HTMLized
output into code. That is; if you reverse the redirected output:

    $ smi -n README.html > README.code

**smi** will have converted all of the HTML tag fragments into their
HTML entities! For example the left angle bracket "`<`" becomes "`&lt;`".
In other words; it will convert the meta-characters from it's own output
into their equivilent HTML entities.

The same goes for all the other meta-characters generated by **smi**.

This makes it a snap to create code fragments to include in your web
pages.

I'm sure there are a number of other "features" I haven't *yet* thought of.
But I'll bet you'll find them. :)

BUGS / TODO
-----------

Strictly speaking; Markdown supports the <cite> fragment. **smi** doesn't
*yet* properly cope with them. smi version 1.5 will correct this, and any
other *bugs* that might be reported before it's release.

**smi** is (c) 2014, Chris Hutchinson  
**smi** is based on work by Enno boland  
Please see [LICENSE](LICENSE), for usage, and any possible restrictions.

The [smi](http://BSDforge.com/projects/textproc/smi/) web site will always
have the most recent version, and any other related information.

  
